﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace kresleni
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            pictureBox_SizeChanged(null, null);
        }

        private void runMenuItem_Click(object sender, EventArgs e)
        {
            Graphics g = Graphics.FromImage (pictureBox.Image);
            g.DrawLine (new Pen (Color.Red), 10, 10, 100, 100);
            pictureBox.Invalidate ();
        }

        private void quitMenuItem_Click(object sender, EventArgs e)
        {
            Close ();
        }

        int X0, Y0;
        bool click;
        Image save;
        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            click = true;
            save = new Bitmap (pictureBox.Image);
        }
        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (click)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                g.DrawLine (pen, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            click = false;
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Image old = pictureBox.Image;
            int W = pictureBox.Width;
            int H = pictureBox.Height;
            if (old != null)
            {
                if (W < old.Width) W = old.Width;
                if (H < old.Height) H = old.Height;
            }
            Image nxt = new Bitmap (W, H);
            Graphics g = Graphics.FromImage (nxt);
            g.FillRectangle (new SolidBrush(Color.White), 0, 0, W, H);
            if (old != null)
               g.DrawImage (old, 0, 0);
            pictureBox.Image = nxt;
        }

        int cnt = 1;

        private void newColorMenuItem_Click(object sender, EventArgs e)
        {
            Panel p = new Panel();
            toolbar.Controls.Add(p);
            p.BackColor = Color.Blue;
            cnt ++;
            p.Left = panel1.Left + (cnt - 1) * (panel1.Width + panel1.Left);
            p.Top = panel1.Top;
            p.Width = panel1.Width;
            p.Height = panel1.Height;
            p.MouseDown += panel1_MouseDown;
        }

        Pen pen = new Pen (Color.Green);
        Brush brush = new SolidBrush (Color.Orange);

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Panel p = (Panel) sender;
            if (e.Button == MouseButtons.Left)
                pen = new Pen(p.BackColor);
            else if (e.Button == MouseButtons.Right)
                brush = new SolidBrush (p.BackColor);
            else if (e.Button == MouseButtons.Middle)
            {
                colorDialog1.Color = p.BackColor;
                if (colorDialog1.ShowDialog() == DialogResult.OK)
                {
                    p.BackColor = colorDialog1.Color;
                    pen = new Pen(p.BackColor);
                }
            }
        }

    }
}
